routes/web.php
<?php

use Illuminate\Support\Facades\Route;
use App\Http\Controllers\CategoryController;
use App\Http\Controllers\CourseController;
use App\Http\Controllers\LevelController;
use App\Http\Controllers\UserController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
})->middleware('auth');

Route::resource('category', CategoryController::class)->middleware('auth');
Route::resource('course', CourseController::class)->middleware('auth');
Route::resource('level', LevelController::class)->middleware('auth');
Route::resource('user', UserController::class)->middleware('auth');


Auth::routes();

Route::get('/home', [App\Http\Controllers\HomeController::class, 'index'])->name('home')->middleware('auth');

app/Models/Category.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Category extends Model
{
    use HasFactory;

    protected $guarded = [];


    public function statusOptions(){
        return [
            1 => 'Active',
            0 => 'Inactive',
            2 => 'In-Progress'
        ];
    }
}

app/Http/Controllers/CategoryController.php
<?php

namespace App\Http\Controllers;

use App\Models\Category;
use Illuminate\Http\Request;

class CategoryController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {

        $categories = Category::all();
        return view('category.index', compact('categories'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $category = new Category();
        return view('category.create', compact('category'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
//        dd($request);//die();
        if(!isset($request['status'])){
            $request['status'] = 0;
        }
        $category = Category::create($this->validateRequest());
        return redirect('category');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Category  $category
     * @return \Illuminate\Http\Response
     */
    public function show(Category $category)
    {
        return view('category.show',compact('category'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Category  $category
     * @return \Illuminate\Http\Response
     */
    public function edit(Category $category)
    {
        return view('category.edit', compact('category'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Category  $category
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Category $category)
    {

        if(!isset($request['status'])){
            $request['status'] = 0;
        }
        $category->update($this->validateRequest());
        //dd($request);
        return redirect('category/'.$category->id);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Category  $category
     * @return \Illuminate\Http\Response
     */
    public function destroy(Category $category)
    {
        $category->delete();
        return redirect('category');
    }

    private function validateRequest()
    {
        return \request()->validate([
            'ar_name' => 'required',
            'en_name' => 'required',
            'status' => 'integer',
        ]);
    }
}

resources/views/category/create.blade.php
@extends('layouts.app')

@section('title', 'Add New Category')


@section('content')

    <div class="row">
        <div class="col-12">
            <form action="{{route('category.store')}}" method="POST" class="" enctype="multipart/form-data">

                @include('category.form')

            </form>
        </div>
    </div>
    <hr>

@endsection()

resources/views/category/edit.blade.php
@extends('layouts.app')

@section('title', 'Edit Details for '. $category->en_name)


@section('content')
    <div class="row">
        <div class="col-12">
            <h1>Edit Details for {{ $category->en_name }}</h1>
        </div>
    </div>

    <div class="row">
        <div class="col-12">
            <form action=" {{route('category.update', ['category' => $category])}}" method="POST" class="" enctype="multipart/form-data">
                @method('PATCH')
                @include('category.form')

            </form>
        </div>
    </div>
    <hr>

@endsection()

resources/views/category/form.blade.php
@csrf
<div class="col-md-6 col-12">
    <div class="card" style="height: 420.283px;">
        <div class="card-header">
            <h4 class="card-title">@yield('title')</h4>
        </div>
        <div class="card-content">
            <div class="card-body">
                <form class="form form-horizontal">
                    <div class="form-body">
                        <div class="row">
                            <div class="col-12">
                                <div class="form-group row">
                                    <div class="col-md-4">
                                        <span>Arabic Name</span>
                                    </div>
                                    <div class="col-md-8">
                                        <input type="text" name="ar_name" value="{{ old('ar_name') ?? $category->ar_name }}" class="form-control">
                                    </div>
                                    <div>{{ $errors->first('ar_name') }}</div>
                                </div>
                            </div>
                            <div class="col-12">
                                <div class="form-group row">
                                    <div class="col-md-4">
                                        <span>English Name</span>
                                    </div>
                                    <div class="col-md-8">
                                        <input type="text" name="en_name" value="{{ old('en_name') ?? $category->en_name }}" class="form-control">
                                    </div>
                                    <div>{{ $errors->first('en_name') }}</div>
                                </div>
                            </div>
                            <div class="col-12">
                                <div class="form-group row">
                                    <div class="col-md-4">
                                        <span>Status</span>
                                    </div>
                                    <div class="col-md-8">
                                        <div class="custom-control custom-switch custom-switch-success mr-2 mb-1">
                                            <p class="mb-0">Active</p>
                                            <?php
                                                $checked = $category->status ? 'checked': '';
                                            ?>
                                            <input type="checkbox" value="1"  {{ $checked}} class="custom-control-input" id="customSwitch4" name="status">
                                            <label class="custom-control-label" for="customSwitch4"></label>
                                        </div>
                                        <div>{{ $errors->first('status') }}</div>
                                    </div>
                                </div>
                            </div>
                            <div class="col-md-8 offset-md-4">
                                <button type="submit" class="btn btn-primary mr-1 mb-1 waves-effect waves-light">Submit</button>
                            </div>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>

resources/views/category/index.blade.php
<?php
?>
@extends('layouts.app')

@section('title', 'Categories List')


@section('content')
    <section id="grid-options" class="row">
        <div class="col-md-12">
            <div class="card">
                <div class="card-header">
                    <h4 class="card-title">@yield('title')</h4>
                    <a class="btn btn-success btn-sm pull-right" href="{{route('category.create')}}">Create</a>
                </div>
                <div class="card-content">
                    <div class="card-body">
                        <div class="table-responsive">
                            <table class="table table-bordered table-striped">
                                <thead>
                                <tr>
                                    <th></th>
                                    <th class="text-center">
                                       English Name
                                    </th>
                                    <th class="text-center">
                                       Arabic Name
                                    </th>
                                    <th class="text-center">
                                        Status
                                    </th>
                                    <th class="text-center">
                                        Actions
                                    </th>
                                </tr>
                                </thead>
                                <tbody style="text-align: center">
                                @foreach($categories as $category)
                                    <tr>
                                        <td> {{ $category->id }}</td>
                                        <td><a href="/category/{{ $category->id }}">{{ $category->en_name }}</a></td>
                                        <td>{{ $category->en_name }}</td>
                                        <td>{{ $category->statusOptions()[$category->status] }}</td>
                                        <td>
                                            <a href="{{route('category.edit', ['category' => $category])}}"><i class="fa fa-edit"></i></a>
                                            <a href="{{route('category.show', ['category' => $category])}}"><i class="fa fa-eye"></i></a>
                                            <form action="{{route('category.destroy', ['category' => $category])}}" method="POST">
                                                @method('DELETE')
                                                @csrf
                                                <button class="btn btn danger" type="submit"><i class="fa fa-trash"></i></button>
                                            </form>
                                        </td>
                                    </tr>
                                @endforeach
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </section>
@endsection()

resources/views/category/show.blade.php
@extends('layouts.app')

@section('title', 'Details for ' . $category->ar_name)


@section('content')
    <div class="row">
        <div class="col-12">
            <h1>{{'Details for ' . $category->ar_name}}</h1>
            <p style="float: right;
padding: 0;
margin: 0;">
                <a href="/category/{{ $category->id }}/edit">Edit</a>
            <form action="/category/{{ $category->id }}" method="POST" style="width: 7%;
float: right;
margin-top: -10px;">
                @method('DELETE')
                @csrf
                <button class="btn btn danger" type="submit">Delete</button>
            </form>
            </p>
        </div>
    </div>
    <div class="row">
        <div class="col-12">
            <table class="table table-bordered table-striped">
                <tr>
                    <th>Id</th>
                    <td>{{$category->id}}</td>
                </tr>
                <tr>
                    <th>Ar Name</th>
                    <td>{{$category->ar_name}}</td>
                </tr>
                <tr>
                    <th>En Name</th>
                    <td>{{$category->en_name}}</td>
                </tr>
            </table>
        </div>
    </div>
@endsection()